package exercicses.ex_d;

import java.util.Stack;

public class FillingThread extends Thread {
    private Stack<Integer> source;
    private Stack<Integer> target;
    private Thread emptyingThread;

    public FillingThread(Stack<Integer> source, Stack<Integer> target, Thread emptyingThread) {
        this.source = source;
        this.target = target;
        this.emptyingThread = emptyingThread;
    }

    @Override
    public void run() {
        try {
            emptyingThread.join();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        System.out.println("--- Starting Filling back ---");
        int v;
        while (!target.isEmpty()) {
            v = target.pop();
            System.out.println("From target stack to source stack " + v);
            source.push(v);
        }
    }
}